
IMPLEMENTATION MODULE Gimnasio;
FROM Cadenas IMPORT Stop,Longitud, Comparar, Asignar;
FROM IO IMPORT WrLn, WrStr, RdLn, RdStr, RdChar, WrChar, RdCard, WrCard;
IMPORT FIO;
FROM Window IMPORT Clear;
FROM Storage IMPORT ALLOCATE, DEALLOCATE, Available;


TYPE

  Actividad=(AEROBIC,PESAS,KARATE,BAILE,MANTENIMIENTO,JUDO,YOGA,TODAS);
  TipoLista=POINTER TO TipoNodo;
  TipoNodo=RECORD
            numsoc:CARDINAL;
            nombre:ARRAY [0..19] OF CHAR;
            cuota:ARRAY [0..9] OF CHAR;
            telef:ARRAY [0..9] OF CHAR;
            sig:TipoLista;
           END;
  TipoClase=ARRAY Actividad OF TipoLista;
  TipoGim=POINTER TO TipoClase;


(*************************************************************)
(***********  PROCEDIMIENTOS AUXILIARES         **************)
(*************************************************************)

(******************************************************)
(* Procedimiento para pasar de una cadena a un enumerado *)
PROCEDURE CadEnu(c1:ARRAY OF CHAR):Actividad;
VAR
BEGIN
   IF Comparar(c1,"AEROBIC")=0 THEN
      RETURN AEROBIC;
   ELSIF Comparar(c1,"PESAS")=0 THEN
      RETURN PESAS;
   ELSIF  Comparar(c1,"KARATE")=0 THEN
      RETURN KARATE;
   ELSIF  Comparar(c1,"BAILE")=0 THEN
      RETURN BAILE;
   ELSIF  Comparar(c1,"MANTENIMIENTO")=0 THEN
      RETURN MANTENIMIENTO;
   ELSIF  Comparar(c1,"JUDO")=0 THEN
      RETURN JUDO;
   ELSIF  Comparar(c1,"YOGA")=0 THEN
      RETURN YOGA;
   ELSIF  Comparar(c1,"TODAS")=0 THEN
      RETURN TODAS;
   END;
END CadEnu;



(******************************************************)
(* Procedimiento que devuelve FALSE si no existe la actividad correspondiente
   a la cadena de caracteres introducida *)
PROCEDURE EstaActividad(c1:ARRAY OF CHAR):BOOLEAN;
VAR
BEGIN
   IF Comparar(c1,"AEROBIC")=0 THEN
      RETURN TRUE;
   ELSIF Comparar(c1,"PESAS")=0 THEN
      RETURN TRUE;
   ELSIF  Comparar(c1,"KARATE")=0 THEN
      RETURN TRUE;
   ELSIF  Comparar(c1,"BAILE")=0 THEN
      RETURN TRUE;
   ELSIF  Comparar(c1,"MANTENIMIENTO")=0 THEN
      RETURN TRUE;
   ELSIF  Comparar(c1,"JUDO")=0 THEN
      RETURN TRUE;
   ELSIF  Comparar(c1,"YOGA")=0 THEN
      RETURN TRUE;
   ELSIF  Comparar(c1,"TODAS")=0 THEN
      RETURN TRUE;
   ELSIF  Comparar(c1,"")=0 THEN
      RETURN TRUE;
   ELSE
      RETURN FALSE;
   END;
END EstaActividad;



(******************************************************)
(* Procedimiento que pasa una enumerado y devuelve un cadena *)
PROCEDURE EnuCad(VAR c1:ARRAY OF CHAR; enu:Actividad);
BEGIN
   CASE enu OF
     | AEROBIC : Asignar(c1,"AEROBIC");
     | PESAS : Asignar(c1,"PESAS");
     | KARATE : Asignar(c1,"KARATE");
     | BAILE : Asignar(c1,"BAILE");
     | MANTENIMIENTO : Asignar(c1,"MANTENIMIENTO");
     | JUDO : Asignar(c1,"JUDO");
     | YOGA : Asignar(c1,"YOGA");
     | TODAS : Asignar(c1,"TODAS");
   END;
END EnuCad;


(******************************************************)
(* Procedimiento que verifica que el nombre del socio est en la lista *)
PROCEDURE EstaSocio(Gim:TipoGim; nom:ARRAY OF CHAR):BOOLEAN;
VAR a:Actividad;
    ptr:TipoLista;
    esta:BOOLEAN;
BEGIN
  esta:=FALSE;
  FOR a:=AEROBIC TO TODAS DO
      ptr:=Gim^[a];
      WHILE (ptr<>NIL) AND NOT(esta) DO
         IF Comparar(ptr^.nombre,nom)=0 THEN
            esta:=TRUE;
         END;
         ptr:=ptr^.sig;
      END;
  END;
  RETURN esta;
END EstaSocio;


(******************************************************)
(* Procedimiento que calcula el nmero maximo de socio *)
PROCEDURE MaximoSocio(Gim:TipoGim):CARDINAL;
VAR a:Actividad;
    ptr:TipoLista;
    num:CARDINAL;
BEGIN
  num:=0;
  FOR a:=AEROBIC TO TODAS DO
      ptr:=Gim^[a];
      WHILE (ptr<>NIL) DO
         IF ptr^.numsoc>=num THEN
            num:=ptr^.numsoc;
         END;
         ptr:=ptr^.sig;
      END;
  END;
  RETURN num;
END MaximoSocio;


(******************************************************)
(* Procedimiento que elimina a un socio de un tipo de actividad *)
PROCEDURE EliminarSocio(VAR lista:TipoLista;nombre:ARRAY OF CHAR);
VAR ant,act:TipoLista;
BEGIN
   ant:=NIL;
   act:=lista;
   IF (act<>NIL) THEN
      WHILE (act^.sig<>NIL) AND (Comparar(act^.nombre,nombre)<>0) DO
        ant:=act;
        act:=act^.sig;
      END;
      IF (lista=act) AND (Comparar(act^.nombre,nombre)=0) THEN
         lista:=lista^.sig;
         DISPOSE(act);
      ELSIF (act^.sig<>NIL) OR (Comparar(act^.nombre,nombre)=0) THEN
         ant^.sig:=act^.sig;
         DISPOSE(act);
      END;
   END;
END EliminarSocio;



(******************************************************)
(* Procedimiento que elimina una lista de socios *)
PROCEDURE DestruirLista(VAR lista:TipoLista);
VAR ptr:TipoLista;
BEGIN
   ptr:=lista;
   WHILE ptr<>NIL DO
      lista:=lista^.sig;
      DISPOSE(ptr);
      ptr:=lista;
   END;
END DestruirLista;


(******************************************************)
(* Procedimiento similar al AnadirSocio pero con un parametro ms *)
(* Borra tambien antiguas referencias del socio                   *)
PROCEDURE AnadirSocioConNumero(VAR Gim:TipoGim; nombre,telef,cuota:ARRAY OF CHAR;
                                   numsoc:CARDINAL; act1,act2:ARRAY OF CHAR;VAR v2,v4,v1:BOOLEAN);
VAR
   a1,a2:Actividad;
   nuevosocio1,nuevosocio2:TipoLista;
   v3:BOOLEAN;
BEGIN
 IF Comparar(act1,"")<>0 THEN
  IF EstaActividad(act1) AND EstaActividad(act2) THEN
   BorrarSocio(Gim,nombre,v3,v1);
   IF Available(SIZE(TipoNodo)) THEN
     a1:=CadEnu(act1);
     NEW(nuevosocio1);
     nuevosocio1^.numsoc:=numsoc;
     Asignar(nuevosocio1^.nombre,nombre);
     Asignar(nuevosocio1^.telef,telef);
     Asignar(nuevosocio1^.cuota,cuota);
     nuevosocio1^.sig:=NIL;
     IF Gim^[a1]=NIL THEN
        Gim^[a1]:=nuevosocio1;
     ELSE
        nuevosocio1^.sig:=Gim^[a1];
        Gim^[a1]:=nuevosocio1;
     END;

     IF Comparar(act2,"")<>0 THEN
      IF Available(SIZE(TipoNodo)) THEN
        a2:=CadEnu(act2);
        NEW(nuevosocio2);
        nuevosocio2^.numsoc:=numsoc;
        Asignar(nuevosocio2^.nombre,nombre);
        Asignar(nuevosocio2^.telef,telef);
        Asignar(nuevosocio2^.cuota,cuota);
        nuevosocio2^.sig:=NIL;
        IF Gim^[a2]=NIL THEN
           Gim^[a2]:=nuevosocio2;
        ELSE
           nuevosocio2^.sig:=Gim^[a2];
           Gim^[a2]:=nuevosocio2;
        END;
      ELSE
        v2:=TRUE;        (*  NoMem para la segunda actividad  *)
      END;
     END;
   ELSE
     v2:=TRUE;           (*  Nomem para la primera actividad  *)
   END;
  ELSE
   v4:=TRUE;             (*  Alguna de las actividades no existe  *)
  END;
 ELSE
   v4:=TRUE;             (*  Primera actividad no puede ser cadena vacia *)
 END;
END AnadirSocioConNumero;


(*************************************************************)
(***********  PROCEDIMIENTOS PRINCIPALES        **************)
(*************************************************************)

(*****************************************)
PROCEDURE CrearGimnasio(VAR v1:BOOLEAN;VAR gim:TipoGim);
VAR a:Actividad;
BEGIN
    v1:=FALSE;
    gim:=NIL;
    IF Available(SIZE(TipoClase)) THEN
      NEW(gim);
      FOR a:=AEROBIC TO TODAS DO
          gim^[a]:=NIL;
      END;
    ELSE
      v1:=TRUE;
    END;
END CrearGimnasio;

(*******************************************)
PROCEDURE AnadirSocio(VAR Gim:TipoGim; nombre,telef,cuota:ARRAY OF CHAR;
                          act1,act2:ARRAY OF CHAR; VAR v2,v4,v1:BOOLEAN);
VAR  a1,a2:Actividad;
     ptr,nuevosocio1,nuevosocio2:TipoLista;
     numsoc:CARDINAL;
BEGIN
IF Gim<>NIL THEN
 IF Comparar(act1,"")<>0 THEN
  IF EstaActividad(act1) AND EstaActividad(act2) THEN
   IF Available(SIZE(TipoNodo)) THEN
     a1:=CadEnu(act1);
     numsoc:=MaximoSocio(Gim)+1;
     NEW(nuevosocio1);
     nuevosocio1^.numsoc:=numsoc;
     Asignar(nuevosocio1^.nombre,nombre);
     Asignar(nuevosocio1^.telef,telef);
     Asignar(nuevosocio1^.cuota,cuota);
     nuevosocio1^.sig:=NIL;
     IF Gim^[a1]=NIL THEN
        Gim^[a1]:=nuevosocio1;
     ELSE
        nuevosocio1^.sig:=Gim^[a1];
        Gim^[a1]:=nuevosocio1;
     END;

     IF Comparar(act2,"")<>0 THEN
      IF Available(SIZE(TipoNodo)) THEN
        a2:=CadEnu(act2);
        NEW(nuevosocio2);
        nuevosocio2^.numsoc:=numsoc;
        Asignar(nuevosocio2^.nombre,nombre);
        Asignar(nuevosocio2^.telef,telef);
        Asignar(nuevosocio2^.cuota,cuota);
        nuevosocio2^.sig:=NIL;
        IF Gim^[a2]=NIL THEN
           Gim^[a2]:=nuevosocio2;
        ELSE
           nuevosocio2^.sig:=Gim^[a2];
           Gim^[a2]:=nuevosocio2;
        END;
      ELSE
        v2:=TRUE;        (*  NoMem para la segunda actividad  *)
      END;
     END;
   ELSE
     v2:=TRUE;           (*  Nomem para la primera actividad  *)
   END;
  ELSE
   v4:=TRUE;             (*  Alguna de las actividades no existe  *)
  END;
 ELSE
   v4:=TRUE;             (*  Primera actividad no puede ser cadena vacia *)
 END;
ELSE
 v1:=TRUE;               (*  La variable global gim no se inicializ     *)
END;
END AnadirSocio;



(*******************************************)
PROCEDURE BorrarSocio(VAR Gim:TipoGim; nombre:ARRAY OF CHAR; VAR v3,v1:BOOLEAN);
VAR a:Actividad;
BEGIN
  v3:=FALSE;
 IF Gim<>NIL THEN
  IF EstaSocio(Gim,nombre) THEN
     FOR a:=AEROBIC TO TODAS DO
         EliminarSocio(Gim^[a],nombre);
     END;
  ELSE
    v3:=TRUE;
  END;
 ELSE
   v1:=TRUE;
 END;
END BorrarSocio;






(*******************************************)
PROCEDURE ModificarSocio(VAR Gim:TipoGim; nombre,nuevacuota:ARRAY OF CHAR;
                             act1,act2:ARRAY OF CHAR ;VAR v3,v2,v4,v1:BOOLEAN);
VAR a:Actividad;
    ptr,ptrsoc:TipoLista;
    esta:BOOLEAN;
    numsoc:CARDINAL;
BEGIN
   v3:=FALSE;
   esta:=FALSE;
 IF Gim<>NIL THEN
   IF EstaSocio(Gim,nombre) THEN
     FOR a:=AEROBIC TO TODAS DO
      ptr:=Gim^[a];
      WHILE (ptr<>NIL) AND NOT(esta) DO
         IF Comparar(ptr^.nombre,nombre)=0 THEN
            esta:=TRUE;
            ptrsoc:=ptr;
         END;
         ptr:=ptr^.sig;
      END;
     END;
     numsoc:=ptrsoc^.numsoc;                 (* Captura del numero de socio *)

    AnadirSocioConNumero(Gim,nombre,ptrsoc^.telef,ptrsoc^.cuota,
                         numsoc,act1,act2,v2,v4,v1);
   ELSE
     v3:=TRUE;
   END;
 ELSE
  v1:=TRUE;
 END;
END ModificarSocio;



(********************************************)
PROCEDURE VisualizarGimnasio(Gim:TipoGim; VAR v1:BOOLEAN);
VAR a:Actividad;
    ptr:TipoLista;
    c1:ARRAY [0..19] OF CHAR;
    i:CARDINAL;
BEGIN
 IF Gim<>NIL THEN
  FOR a:=AEROBIC TO TODAS DO
      i:=0;
      Clear;
      ptr:=Gim^[a];
      EnuCad(c1,a);
      WrStr(c1);
      WrStr("-------------"); WrLn;
      WHILE (ptr<>NIL) DO
        IF i<>4 THEN
         WrStr(" Numero de socio: "); WrCard(ptr^.numsoc,4); WrLn;
         WrStr(" Nombre: "); WrStr(ptr^.nombre); WrLn;
         WrStr(" Telefono: "); WrStr(ptr^.telef); WrLn;
         WrStr(" Cuota: "); WrStr(ptr^.cuota); WrLn;
         WrStr("***"); WrLn;
         ptr:=ptr^.sig;
         i:=i+1;
        ELSE
         i:=0;
         Stop;
        END;
      END;
      Stop;
  END;
 ELSE
   v1:=TRUE;
 END;
END VisualizarGimnasio;



(********************************************)
PROCEDURE VolcarSocios(Gim:TipoGim;VAR v1:BOOLEAN);
VAR NomFich:ARRAY [0..19] OF CHAR;
    Fich:FIO.File;
    ptr:TipoLista;
    a:Actividad;
    c1:ARRAY [0..19] OF CHAR;
BEGIN
  Clear;
  IF Gim<>NIL THEN
     WrStr("--------------------"); WrLn;
     Fich:=FIO.Create("GIMNASIO.DAT");    (*Ojo a como se abre el fichero*)
     FOR a:=AEROBIC TO TODAS DO
         ptr:=Gim^[a];
         EnuCad(c1,a);
         FIO.WrStr(Fich,c1);
         FIO.WrLn(Fich);
         WHILE ptr<>NIL DO
           FIO.WrCard(Fich,ptr^.numsoc,4);
           FIO.WrChar(Fich," ");
           FIO.WrStr(Fich,ptr^.nombre);
           FIO.WrLn(Fich);
           FIO.WrStr(Fich,ptr^.cuota);
           FIO.WrLn(Fich);
           FIO.WrStr(Fich,ptr^.telef);
           FIO.WrLn(Fich);
           ptr:=ptr^.sig;
         END;
         FIO.WrCard(Fich,0,4);
         FIO.WrChar(Fich," ");
     END;
     FIO.Close(Fich);
  ELSE
    v1:=TRUE;
  END;
END VolcarSocios;



(********************************************)
PROCEDURE Fichero_A_TAD(VAR Gim:TipoGim;nom:ARRAY OF CHAR;VAR ex,v1,v2:BOOLEAN);
VAR Fich:FIO.File;
    nuevosocio1:TipoLista;
    numsoc:CARDINAL;
    nombre,nomact:ARRAY [0..19] OF CHAR;
    cuota:ARRAY [0..9] OF CHAR;
    telef:ARRAY [0..9] OF CHAR;
    a1:Actividad;
BEGIN
    IF FIO.Exists(nom) THEN
       DestruirGimnasio(Gim);         (* Liberamos memoria por si acaso *)
       CrearGimnasio(v1,Gim);
       Fich:=FIO.Open(nom);
       FIO.RdStr(Fich,nomact);
       numsoc:=FIO.RdCard(Fich);
       WHILE NOT(FIO.EOF) AND NOT(v2) DO
          WHILE (numsoc<>0) AND NOT(v2) DO
             FIO.RdStr(Fich,nombre);
             FIO.RdStr(Fich,cuota);
             FIO.RdStr(Fich,telef);
             IF Available(SIZE(TipoNodo)) THEN
                 a1:=CadEnu(nomact);
                 NEW(nuevosocio1);
                 nuevosocio1^.numsoc:=numsoc;
                 Asignar(nuevosocio1^.nombre,nombre);
                 Asignar(nuevosocio1^.telef,telef);
                 Asignar(nuevosocio1^.cuota,cuota);
                 nuevosocio1^.sig:=NIL;
                 IF Gim^[a1]=NIL THEN
                     Gim^[a1]:=nuevosocio1;
                 ELSE
                     nuevosocio1^.sig:=Gim^[a1];
                     Gim^[a1]:=nuevosocio1;
                 END;
             ELSE
               v2:=TRUE;
             END;
            numsoc:=FIO.RdCard(Fich);
          END;
        FIO.RdStr(Fich,nomact);
        numsoc:=FIO.RdCard(Fich);
       END;
       FIO.Close(Fich);
    ELSE
       ex:=FALSE;
    END;
END Fichero_A_TAD;


(********************************************)
PROCEDURE DestruirGimnasio(VAR Gim:TipoGim);
VAR a:Actividad;
BEGIN
 IF Gim<>NIL THEN
  FOR a:=AEROBIC TO TODAS DO
     DestruirLista(Gim^[a]);
  END;
  DISPOSE(Gim);
 END;
END DestruirGimnasio;


END Gimnasio.